Index: src/edu/ucsb/nceas/metacat/MetacatReplication.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetacatReplication.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/MetacatReplication.java	(revision 1217)
@@ -241,17 +241,21 @@
                                           HttpServletResponse response)
   {
     String subaction = ((String[])params.get("subaction"))[0];
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
 
     try {
-      conn = util.openDBConnection();
-      PreparedStatement pstmt = null;
-
+      //conn = util.openDBConnection();
+      dbConn=DBConnectionPool.
+               getDBConnection("MetacatReplication.handleServerControlRequest");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      
       // add server to server list
       if ( subaction.equals("add") ) {
         String replicate = ((String[])params.get("replicate"))[0];
         String server = ((String[])params.get("server"))[0];
-        pstmt = conn.prepareStatement("INSERT INTO xml_replication " +
+        pstmt = dbConn.prepareStatement("INSERT INTO xml_replication " +
                                       "(server, last_checked, replicate) " +
                                       "VALUES ('" + server + "', to_date(" +
                                       "'01/01/00', 'MM/DD/YY'), '" +
@@ -258,13 +262,16 @@
                                       replicate + "')");
         pstmt.execute();
         pstmt.close();
-        conn.commit();
+        dbConn.commit();
         out.println("Server " + server + " added"); 
         response.setContentType("text/html");
         out.println("<html><body><table border=\"1\">");
         out.println("<tr><td><b>server</b></td><td><b>last_checked</b></td><td>");
         out.println("<b>replicate</b></td></tr>");
-        pstmt = conn.prepareStatement("SELECT * FROM xml_replication");
+        pstmt = dbConn.prepareStatement("SELECT * FROM xml_replication");
+        //increase dbconnection usage
+        dbConn.increaseUsageCount(1);
+        
         pstmt.execute();
         ResultSet rs = pstmt.getResultSet();
         boolean tablehasrows = rs.next();
@@ -284,17 +291,19 @@
       // delete server from server list
       } else if ( subaction.equals("delete") ) {
         String server = ((String[])params.get("server"))[0];
-        pstmt = conn.prepareStatement("DELETE FROM xml_replication " +
+        pstmt = dbConn.prepareStatement("DELETE FROM xml_replication " +
                                       "WHERE server LIKE '" + server + "'");
         pstmt.execute();
         pstmt.close();
-        conn.commit();
+        dbConn.commit();
         out.println("Server " + server + " deleted");
         response.setContentType("text/html");
         out.println("<html><body><table border=\"1\">");
         out.println("<tr><td><b>server</b></td><td><b>last_checked</b></td><td>");
         out.println("<b>replicate</b></td></tr>");
-        pstmt = conn.prepareStatement("SELECT * FROM xml_replication");
+        pstmt = dbConn.prepareStatement("SELECT * FROM xml_replication");
+        //increase dbconnection usage
+        dbConn.increaseUsageCount(1);
         pstmt.execute();
         ResultSet rs = pstmt.getResultSet();
         boolean tablehasrows = rs.next();
@@ -313,7 +322,7 @@
         out.println("<html><body><table border=\"1\">");
         out.println("<tr><td><b>server</b></td><td><b>last_checked</b></td><td>");
         out.println("<b>replicate</b></td></tr>");
-        pstmt = conn.prepareStatement("SELECT * FROM xml_replication");
+        pstmt = dbConn.prepareStatement("SELECT * FROM xml_replication");
         pstmt.execute();
         ResultSet rs = pstmt.getResultSet();
         boolean tablehasrows = rs.next();
@@ -326,7 +335,7 @@
         out.println("</table></body></html>");
       }
       pstmt.close();
-      conn.close();
+      //conn.close();
 
     } catch(Exception e) {
       System.out.println("Error in " + 
@@ -334,6 +343,24 @@
                          e.getMessage());
       e.printStackTrace(System.out);
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      catch (SQLException ee)
+      {
+        MetaCatUtil.debugMessage("Error in " + 
+                "MetacatReplication.handleServerControlRequest to close pstmt "
+                 + ee.getMessage());
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
+      
   }
   
   // download certificate with the public key from certURL and 
@@ -408,6 +435,8 @@
     String dbaction = "UPDATE"; // the default action is UPDATE
     boolean override = false;
     int serverCode = 1;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
    
     try {
       //if the url contains a dbaction then the default action is overridden
@@ -443,12 +472,16 @@
       String homeServer=(String)docinfoHash.get("home_server");
       util.debugMessage("homeServer: "+homeServer,20);
       // write the document here
-      Connection conn = util.openDBConnection();
-      DocumentImpl.writeReplication(conn, new StringReader(xmldoc), null, null,
-              dbaction, docid, user, null, homeServer, false);
+      //Connection conn = util.openDBConnection();
+      dbConn=DBConnectionPool.
+              getDBConnection("MetacatReplication.handleForceReplicateRequest");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      DocumentImpl.writeReplication(dbConn, 
+                  new StringReader(xmldoc), null, null, dbaction, docid, user, 
+                  null, homeServer, false);
               
        
-      conn.close();
+      //conn.close();
 
       MetacatReplication.replLog("document " + docid + " added to DB with " +
                                  "action " + dbaction);
@@ -458,6 +491,10 @@
                          "Request(): " + e.getMessage());
        e.printStackTrace();
     }
+    finally
+    {
+      DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+    }//finally
   }
   
   /**
@@ -489,7 +526,7 @@
     boolean override = false;
     int serverCode = 1;
     String dbaction=null;
-    Connection conn=null;
+    //Connection conn=null;
     
     try 
     {
@@ -534,9 +571,9 @@
       //the xml_documents
       if (dbaction.equals("delete"))
       {
-        conn = util.getConnection();
-        DocumentImpl.delete(conn,docid,user,null);
-        util.returnConnection(conn);
+        //conn = util.getConnection();
+        DocumentImpl.delete(docid,user,null);
+        //util.returnConnection(conn);
       }
       //To data file insert or update is same
       else if (dbaction.equals("insert")||dbaction.equals("update"))
@@ -560,7 +597,7 @@
     } catch(Exception e) 
     {
       
-      util.returnConnection(conn);
+      //util.returnConnection(conn);
       util.debugMessage("ERROR in MetacatReplication.handleForceReplicate" +
                          "Request(): " + e.getMessage(), 30);
     }
@@ -575,14 +612,14 @@
   private void handleGetLockRequest(PrintWriter out, Hashtable params,
                                     HttpServletResponse response)
   {
-    Connection conn = null;
+    //Connection conn = null;
     try
     {
-      conn = MetacatReplication.getDBConnection("MetacatReplication." +
-                                                "handleGetLockRequest");
+      /*conn = MetacatReplication.getDBConnection("MetacatReplication." +
+                                                "handleGetLockRequest");*/
       String docid = ((String[])params.get("docid"))[0];
       String remoteRev = ((String[])params.get("updaterev"))[0];
-      DocumentImpl requestDoc = new DocumentImpl(conn, docid);
+      DocumentImpl requestDoc = new DocumentImpl(docid);
       MetacatReplication.replLog("lock request for " + docid);
       int localRevInt = requestDoc.getRev();
       int remoteRevInt = Integer.parseInt(remoteRev);
@@ -612,7 +649,7 @@
         MetacatReplication.replLog("lock denied for " + docid + 
                                    "reason: client has outdated file");
       }
-      conn.close();
+      //conn.close();
     }
     catch(Exception e)
     {
@@ -634,12 +671,12 @@
   {
     String docid = ((String[])(params.get("docid")))[0];
     StringBuffer sb = new StringBuffer();
-    Connection conn = null;
+    //Connection conn = null;
     try
     {
-      conn = MetacatReplication.getDBConnection("MetacatReplication." +
-                                                "handleGetDocumentInfoRequest");
-      DocumentImpl doc = new DocumentImpl(conn, docid);
+      /*conn = MetacatReplication.getDBConnection("MetacatReplication." +
+                                              "handleGetDocumentInfoRequest");*/
+      DocumentImpl doc = new DocumentImpl(docid);
       sb.append("<documentinfo><docid>").append(docid);
       sb.append("</docid><docname>").append(doc.getDocname());
       sb.append("</docname><doctype>").append(doc.getDoctype());
@@ -655,7 +692,7 @@
       sb.append("</rev></documentinfo>");
       response.setContentType("text/xml");
       out.println(sb.toString());
-      conn.close();
+      //conn.close();
     }
     catch (Exception e)
     {
@@ -792,7 +829,7 @@
   private void handleGetDocumentRequest(PrintWriter out, Hashtable params, 
                                         HttpServletResponse response)
   {
-    Connection conn = null;
+    //Connection dbConn = null;
     try
     {
       //try to open a https stream to test if the request server's public key
@@ -811,12 +848,12 @@
       }
       
       String docid = ((String[])(params.get("docid")))[0];
-      conn = MetacatReplication.getDBConnection("MetacatReplication." +
-                                                "handleGetDocumentRequest");
-      DocumentImpl di = new DocumentImpl(conn, docid);
+      /*conn = MetacatReplication.getDBConnection("MetacatReplication." +
+                                                "handleGetDocumentRequest");*/
+      DocumentImpl di = new DocumentImpl(docid);
       response.setContentType("text/xml");
       out.print(di.toString());
-      conn.close();
+      //conn.close();
       MetacatReplication.replLog("document " + docid + " sent");
     
     }
@@ -849,7 +886,9 @@
   private void handleUpdateRequest(PrintWriter out, Hashtable params, 
                                     HttpServletResponse response)
   {
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
     try
     {
       //try to open a https stream to test if the request server's public key
@@ -893,9 +932,12 @@
         delsql.append("and server_location = 1");
       }
      
-      conn = MetacatReplication.getDBConnection("MetacatReplication." +
-                                                "handleUpdateRequest");
-      PreparedStatement pstmt = conn.prepareStatement(docsql.toString());
+      /*conn = MetacatReplication.getDBConnection("MetacatReplication." +
+                                                "handleUpdateRequest");*/
+      dbConn=DBConnectionPool.
+                  getDBConnection("MetacatReplication.handleUpdateRequest");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt = dbConn.prepareStatement(docsql.toString());
       pstmt.execute();
       ResultSet rs = pstmt.getResultSet();
       boolean tablehasrows = rs.next();
@@ -975,7 +1017,10 @@
         }//while
       }//else
       
-      pstmt = conn.prepareStatement(delsql.toString());
+      pstmt = dbConn.prepareStatement(delsql.toString());
+      //usage count should increas 1
+      dbConn.increaseUsageCount(1);
+      
       pstmt.execute();
       rs = pstmt.getResultSet();
       tablehasrows = rs.next();
@@ -1002,7 +1047,7 @@
       doclist.append("</updates></replication>");
       MetaCatUtil.debugMessage("doclist: " + doclist.toString());
       pstmt.close();
-      conn.close();
+      //conn.close();
       response.setContentType("text/xml");
       out.println(doclist.toString());
      
@@ -1015,6 +1060,25 @@
       response.setContentType("text/xml");
       out.println("<error>e.getMessage()</error>");
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      catch (SQLException ee)
+      {
+        MetaCatUtil.debugMessage("Error in MetacatReplication." +
+                "handleUpdaterequest to close pstmt: "+ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
+        
+                        
+      
     
   }
   
@@ -1041,13 +1105,17 @@
                                                 HttpServletResponse response,
                                                 boolean printFlag)
   {
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     PreparedStatement pstmt = null;
     try
     { 
-      conn = MetacatReplication.getDBConnection("MetacatReplication." +
-                                                "handleGetCatalogRequest");
-      pstmt = conn.prepareStatement("select entry_type, " +
+      /*conn = MetacatReplication.getDBConnection("MetacatReplication." +
+                                                "handleGetCatalogRequest");*/
+      dbConn=DBConnectionPool.
+                 getDBConnection("MetacatReplication.handleGetCatalogRequest");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt = dbConn.prepareStatement("select entry_type, " +
                               "source_doctype, target_doctype, public_id, " +
                               "system_id from xml_catalog");
       pstmt.execute();
@@ -1067,7 +1135,7 @@
         tablehasrows = rs.next();
       }
       sb.append("</xml_catalog>");
-      conn.close();
+      //conn.close();
       if(printFlag)
       {
         response.setContentType("text/xml");
@@ -1078,17 +1146,29 @@
     }
     catch(Exception e)
     {
-      try
-      {
-        pstmt.close();
-        conn.close();
-      }
-      catch(Exception ee)
-      {}
+      
       System.out.println("error in MetacatReplication.handleGetCatalogRequest:"+ 
                           e.getMessage());
       e.printStackTrace(System.out);
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      catch (SQLException ee)
+      {
+        MetaCatUtil.
+           debugMessage("Error in MetacatReplication.handleGetCatalogRequest: "
+           +ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
+      
     return null;
   }
   
@@ -1145,15 +1225,18 @@
   public static String getServer(int serverCode)
   {
     //System.out.println("serverid: " + serverCode);
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
     try
     {
-      conn = MetacatReplication.getDBConnection("MetacatReplication." +
-                                                "getServer");
+      dbConn=DBConnectionPool.
+                  getDBConnection("MetacatReplication.getServer");
+      serialNumber=dbConn.getCheckOutSerialNumber();
       String sql = new String("select server from " +
                               "xml_replication where serverid = " + 
                               serverCode);
-      PreparedStatement pstmt = conn.prepareStatement(sql);
+      pstmt = dbConn.prepareStatement(sql);
       //System.out.println("getserver sql: " + sql);
       pstmt.execute();
       ResultSet rs = pstmt.getResultSet();
@@ -1163,8 +1246,8 @@
         //System.out.println("server: " + rs.getString(1));
         return rs.getString(1);
       }
-      pstmt.close();
-      conn.close();
+      
+      //conn.close();
     }
     catch(Exception e)
     {
@@ -1171,6 +1254,25 @@
       System.out.println("Error in MetacatReplication.getServer: " + 
                           e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      catch (SQLException ee)
+      {
+        MetaCatUtil.debugMessage("Error in MetacactReplication.getserver: "+
+                                    ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//fianlly
+    }//finally
+        
+      
+        
     return null;
       //return null if the server does not exist
   }
@@ -1183,14 +1285,18 @@
    */
   public static int getServerCode(String server) throws Exception
   {
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     PreparedStatement pstmt = null;
     int serverCode = 0;
 
     try {
 
-      conn = util.openDBConnection();
-      pstmt = conn.prepareStatement("SELECT serverid FROM xml_replication " +
+      //conn = util.openDBConnection();
+      dbConn=DBConnectionPool.
+                  getDBConnection("MetacatReplication.getServerCode");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt = dbConn.prepareStatement("SELECT serverid FROM xml_replication " +
                                     "WHERE server LIKE '" + server + "'");
       pstmt.execute();
       ResultSet rs = pstmt.getResultSet();
@@ -1198,7 +1304,7 @@
       if ( tablehasrows ) {  
         serverCode = rs.getInt(1);
         pstmt.close();
-        conn.close();
+        //conn.close();
         return serverCode;
       }
       
@@ -1206,11 +1312,22 @@
       throw e;
 
     } finally {
-      try {
+      try 
+      {
         pstmt.close();
-        conn.close();
-      } catch(Exception ee) {}
-    }
+        //conn.close();
+       }//try
+       catch(Exception ee) 
+       {
+         MetaCatUtil.debugMessage("Error in MetacatReplicatio.getServerCode: "
+                                  +ee.getMessage(), 30);
+                           
+       }//catch
+       finally
+       {
+         DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+       }//finally
+    }//finally
     
     return serverCode;
   }
@@ -1270,12 +1387,15 @@
    */
   public static boolean replToServer(String server)
   {
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     PreparedStatement pstmt = null;
     try
     {
-      conn = MetacatReplication.getDBConnection("MetacatReplication.replToServer");
-      pstmt = conn.prepareStatement("select replicate from " + 
+      dbConn=DBConnectionPool.
+                  getDBConnection("MetacatReplication.repltoServer");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt = dbConn.prepareStatement("select replicate from " + 
                                     "xml_replication where server like '" +
                                      server + "'");
       pstmt.execute();
@@ -1287,13 +1407,13 @@
         if(i == 1)
         {
           pstmt.close();
-          conn.close();
+          //conn.close();
           return true;
         }
         else
         {
           pstmt.close();
-          conn.close();
+          //conn.close();
           return false;
         }
       }
@@ -1308,59 +1428,21 @@
       try
       {
         pstmt.close();
-        conn.close();
-      }
+        //conn.close();
+      }//try
       catch(Exception ee)
-      {}
-    }
+      {
+        MetaCatUtil.debugMessage("Error in MetacatReplication.replToServer: "
+                                  +ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
     return false;
     //the default if this server does not exist is to not replicate to it.
   }
   
-  /**
-   * A method for redundantly trying to connect.  this method will attempt to 
-   * connect to the DB 3 times before failing.
-   * @param methodname the methodname from which this method is called.
-   */
-  public static Connection getDBConnection(String methodname) throws Exception
-  {
-    Connection conn = null;
-    try
-    {
-      try
-      { //this connection is prone to error for some reason so we 
-        //try to connect it three times before quiting.
-        conn = util.openDBConnection();
-        return conn;
-      }
-      catch(SQLException sqle)
-      {
-        try
-        {
-          conn = util.openDBConnection();
-          return conn;
-        }
-        catch(SQLException sqlee)
-        {
-          try
-          {
-            conn = util.openDBConnection();
-            return conn;
-          }
-          catch(SQLException sqleee)
-          {
-            System.out.println("error getting db connection in " + 
-                               methodname +  ": " +
-                               sqleee.getMessage());
-            return conn;
-          }
-        }
-      }
-    }
-    catch(Exception e)
-    {
-      throw new java.lang.Exception("error in " + methodname + ": " + 
-                          e.getMessage());
-    }
-  }
+  
 }
